<?php

declare(strict_types=1);

namespace FiloBlu\RuleDayFromBirthday\Controller\Adminhtml\Promo\Quote;

use Exception;
use FiloBlu\RuleDayFromBirthday\Block\Adminhtml\Promo\Quote\Edit\Tab\Coupons\Grid;
use Magento\Framework\App\Filesystem\DirectoryList;
use Magento\Framework\App\ResponseInterface;
use Magento\Framework\Controller\ResultInterface;
use Magento\SalesRule\Controller\Adminhtml\Promo\Quote;
use Magento\SalesRule\Model\RegistryConstants;

/**
 * @class ExportCouponsCsv
 * @package FiloBlu\RuleDayFromBirthday\Controller
 */
class ExportCouponsCsv extends Quote
{
    /**
     * @return ResponseInterface|ResultInterface|void
     * @throws Exception
     */
    public function execute()
    {
        $this->_initRule();
        $rule = $this->_coreRegistry->registry(RegistryConstants::CURRENT_SALES_RULE);
        if ($rule->getId()) {
            $fileName = 'coupon_codes.csv';
            $content = $this->_view->getLayout()->createBlock(
                Grid::class
            )->getCsvFile();

            return $this->_fileFactory->create($fileName, $content, DirectoryList::VAR_DIR);
        }

        $this->_redirect('sales_rule/*/detail', ['_current' => true]);
    }
}
