<?php

declare(strict_types=1);

namespace FiloBlu\RuleDayFromBirthday\Helper;

use Magento\Framework\App\Helper\AbstractHelper;
use Magento\Framework\App\Helper\Context;

/**
 * @class TransformerHelper
 * @package FiloBlu\BirthdayCoupon\Helper
 */
class TransformerHelper extends AbstractHelper
{

    /**
     * @param Context $context
     */
    public function __construct(Context $context)
    {
        parent::__construct($context);
    }

    /**
     * @param array $subscribers
     * @return array
     */
    public function transformSubscribers(array $subscribers): array
    {
        foreach ($subscribers as $key => $subscriber) {
            $subscribers[$key] = [
                'store_id' => $subscriber['store_id'] ?? '',
                'email' => $subscriber['subscriber_email'] ?? '',
                'dob' => $subscriber['dob'] ?? '',
            ];
        }

        return $subscribers;
    }

    /**
     * @param array $customers
     * @return array
     */
    public function transformCustomers(array $customers): array
    {
        foreach ($customers as $key => $customer) {
            $customers[$key] = [
                'store_id' => $customer['store_id'] ?? '',
                'email' => $customer['email'] ?? '',
                'dob' => $customer['dob'] ?? '',
            ];
        }

        return $customers;
    }
}
